<template>
  <div class="container">
    <div v-bind:id="'dropList' + index"
         v-bind:key="index"
         class="list-column droppable isRelative"
         @dragover="allowDrop"
         @drop="drop">
      <TeamNamePlate
        v-bind:teamName="team.teamName">
      </TeamNamePlate>
      <ActionButtonIndexRequired
        class="isAbsolute pullToUpperRightCorner"
        :method="removeTeam"
        v-bind:index="index"
        buttonText="X">
      </ActionButtonIndexRequired>
      <CardButtonIndexRequired
        class="card"
        :method="displayAddMemberForm"
        v-bind:index="index"
        cardText="Add new member">
      </CardButtonIndexRequired>
      <TeamMember
        v-for="member in team.members"
        v-bind:key="member.id"
        v-bind:member="member"
        v-bind:index="index">
      </TeamMember>
      <AddMemberForm
        v-bind:index="index">
      </AddMemberForm>
    </div>
  </div>
</template>

<script>
import TeamMember from './TeamMember';
import AddMemberForm from './AddMemberForm';
import ActionButtonIndexRequired from './ActionButtonIndexRequired';
import TeamNamePlate from './TeamNamePlate';
import CardButtonIndexRequired from './CardButtonIndexRequired';

export default {
  name: 'Team',
  components: {
    CardButtonIndexRequired,
    TeamNamePlate,
    ActionButtonIndexRequired,
    AddMemberForm,
    TeamMember,
  },
  props: ['team', 'index'],
  methods: {
    allowDrop(ev) {
      ev.preventDefault();
    },
    drop(ev) {
      ev.preventDefault();
      const data = ev.dataTransfer.getData('text');
      const draggedItem = document.getElementById(data);
      const teamID = parseInt(ev.currentTarget.id.slice(8, 9), 10);
      const memberID = parseInt(data.slice(5), 10);
      const fullName = draggedItem.children[1].innerText;
      const firstName = fullName.substr(0, fullName.indexOf(' '));
      const lastName = fullName.substr(fullName.indexOf(' ') + 1);
      this.transferMember(teamID, memberID, firstName, lastName);
    },
    removeTeam(teamID) {
      const payload = {};
      payload.teamID = parseInt(teamID, 10);
      this.$store.commit('removeTeam', payload);
    },
    transferMember(teamID, memberID, firstName, lastName) {
      const payload = {};
      payload.teamID = teamID;
      payload.memberID = memberID;
      payload.firstName = firstName;
      payload.lastName = lastName;
      this.$store.dispatch('transferMember', payload);
    },
    displayAddMemberForm() {
      const memberFormContainer = this.$el.querySelector('.memberFormContainer');
      if (memberFormContainer.classList.contains('invisible')) {
        memberFormContainer.classList.remove('invisible');
        memberFormContainer.classList.add('visible');
      }
    },
  },
};
</script>

<style scoped>
  [draggable=true] {
    cursor: -webkit-grab;
  }
  .isRelative {
    position: relative;
  }
  .isAbsolute {
    position: absolute;
  }
  .pullToUpperRightCorner {
    top: 5px;
    right: 5px;
  }
  .container {
    display: grid;
    grid-gap: 10px;
    background-color: rgba(0, 0, 0, 0.1);
    min-height: 300px;
    max-width: 300px;
    margin: auto;
  }
  .list-column {
    display: grid;
    justify-items: center;
    align-items: center;
    background-color: rgba(0, 0, 0, 0.05);
  }
  .card {
    display: block;
    width: 100%;
    height: 50px;
    border-radius: 5px;
    border-color: grey;
    background-color: rgba(0, 0, 0, 0.2);
  }
  .card:not(:last-child) {
    margin-bottom: 5px;
  }
</style>
